/********************************************************************
* Filename: temp.c 													*
* Date: 29/06/2007 													*
* File Version: 1.00 												*
* Temperatur messen Funktionenwandelt AD wert in Temp wert um		*
*	-int_2_temp()													*
*																	*					
* Linker File: p30f6012.gld 										*
* last modified by S.FISCHER 										*
*********************************************************************/

#include "p30f5015.h"
#include "ADC.h"
#include "error_handle.h"
#include "globalvar.h"

signed long __builtin_muluu(const unsigned int p0,const unsigned int p1);
//				temp,AD-value		
int temptab[37][2]={	
				{55,146},
				{50,203},
				{45,277},
				{40,374},
				{35,494},
				{30,642},
				{25,818},
				{20,1020},
				{15,1246},
				{10,1489},
				{5,1743},
				{0,	2000},
				{5,	2250},
				{10,2488},
				{15,2708},
				{20,2906},
				{25,3082},
				{30,3236},
				{35,3368},
				{40,3482},
				{45,3577},
				{50,3658},
				{55,3726},
				{60,3783},
				{65,3831},
				{70,3871},
				{75,3904},
				{80,3932},
				{85,3956},
				{90,3976},
				{95,3993},
				{100,4007},
				{105,4019},
				{110,4030},
				{115,4038},
				{120,4046},
				{125,4052} 
				};





void int_2_temp (unsigned char *buffer, int AD_value)
{

int i=0;
int b0,b1,b2,b3,b4,b5,b6;
while(i!=38)    //solange bis alle tabellen werte berprft
{
	if (temptab[i][1]>=AD_value)   //passender AD-wert dann gib dazugehoerende Temp aus
    {
		int_2_ascii(buffer,temptab[i][0],6);//tempwert in Ascii wandeln
		i=37;								//schleife verlassen						
	}
i++;
}


if (AD_value<2000)  //wenn AD wert kleiner 2000 negative Temp
buffer[0]='-';
buffer[7]='C';
buffer[8]='\0';



b0=buffer[0];
b1=buffer[1];
b2=buffer[2];
b3=buffer[3];
b4=buffer[4];
b5=buffer[5];
b6=buffer[6];
}

void int_2_temp2 (unsigned char *buffer,int AD_value)
{
long int temp=0,temp1=0;
long int ad_quadrat=0;
AD_value=AD_value<<2;     //mal 4 fuer 10 Bit 1024*4=4096
ad_quadrat=__builtin_muluu(AD_value,AD_value); //hier wird die quadratische funktion
ad_quadrat=ad_quadrat*82; 						//f(x)= 131720 + 5628*x -0,64*x^2
ad_quadrat=ad_quadrat>>7;						//realisiert
temp=__builtin_muluu(AD_value,88);
temp=temp<<6;
temp1=131720-ad_quadrat;
temp=temp+temp1;
temp=temp>>17; 
if (temp>100) error_type=TEMP_ERROR; 
int_2_ascii(buffer,temp,5);
//if(AD_value<168)
//buffer[0]='-';
buffer[5]='C';
buffer[6]='\0';
}
