/********************************************************************
* Filename: error_handle.c 													*
* Date: 29/06/2007 													*
* File Version: 1.00 												*
* Blink Fehlercodes je nach Aufgetretenem Fehler		*
*	-error_blink(error)													*
*																	*					
* Linker File: p30f6012.gld 										*
* last modified by S.FISCHER 										*
*********************************************************************/

#include "p30f5015.h"
#include "globalvar.h"
#include "delay.h"
#include "USART.h"
#include "stdio.h"
#include "delay.h"
#include "error_handle.h"

void error_handle()
{

switch(error_type)	
{
	case INT4_ERROR:
	{
	
		asm ("CLRWDT"); //alle 128ms muss der watchdog zurckgesetzt werden, sonst RESET
	//	LATBbits.LATB15 = 0; //Turn on LED1 funktionstest
		LATBbits.LATB15 ^= 1; //Turn on LED1 Blink
		delay_ms(100);
		putch('\f');
		sprintf (buffer,"INT4 ERROR\v");
		text_out(buffer);
		putch('\r');
		while (!U1STAbits.TRMT); //Warten bis alles gesendet
		asm("reset");
	
		break;
	}

	case IC3_ERROR:
	{
	
		
		asm ("CLRWDT"); //alle 128ms muss der watchdog zurckgesetzt werden, sonst RESET
	//	LATBbits.LATB15 = 0; //Turn on LED1 funktionstest
		LATBbits.LATB15 ^= 1; //Turn on LED1 Blink
		delay_ms(100);
		putch('\f');
		sprintf (buffer,"IC3 ERROR\v");
		text_out(buffer);
		putch('\r');
		while (!U1STAbits.TRMT);//Warten bis alles gesendet
		asm("reset");
	
		break;
	}

	case TRAP_ERROR:
	{
	
		asm ("CLRWDT"); //alle 128ms muss der watchdog zurckgesetzt werden, sonst RESET
	//	LATBbits.LATB15 = 0; //Turn on LED1 funktionstest
		LATBbits.LATB15 ^= 1; //Turn on LED1 Blink
		delay_ms(100);
		putch('\f');
		sprintf (buffer,"ERROR TRAP CAUSED\v");
		text_out(buffer);
		putch('\r');
		while (!U1STAbits.TRMT);//Warten bis alles gesendet
		asm("reset");
	
		break;
	}
	case WDT_ERROR:
	{
	
		asm ("CLRWDT"); //alle 128ms muss der watchdog zurckgesetzt werden, sonst RESET
	//	LATBbits.LATB15 = 0; //Turn on LED1 funktionstest
		LATBbits.LATB15 ^= 1; //Turn on LED1 Blink
		delay_ms(100);
		putch('\f');
		sprintf (buffer,"WDT OVERRUN ERROR\v");
		text_out(buffer);
		putch('\r');
		while (!U1STAbits.TRMT); //Warten bis alles gesendet
		asm("reset");
	
		break;
	}

	default:
	{
		
	break;
	}
}
	
} 

